# This is the SAM template that represents the architecture of your serverless application
# https://docs.aws.amazon.com/serverless-application-model/latest/developerguide/serverless-sam-template-basics.html

# The AWSTemplateFormatVersion identifies the capabilities of the template
# https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/format-version-structure.html
AWSTemplateFormatVersion: 2010-09-09
Description: >-
  local-sam

# Transform section specifies one or more macros that AWS CloudFormation uses to process your template
# https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/transform-section-structure.html
Transform:
  - AWS::Serverless-2016-10-31

Parameters:
  Env:
    Type: String
    Default: production
  FunctionTimeout:
    Type: Number
    Default: 5
  QueueTimeout:
    Type: Number
    Default: 100

# Resources declares the AWS resources that you want to include in the stack
# https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/resources-section-structure.html
Resources:
  # Each Lambda function is defined by properties:
  # https://github.com/awslabs/serverless-application-model/blob/master/versions/2016-10-31.md#awsserverlessfunction

  FunctionRole:
    Type: AWS::IAM::Role
    Properties:
      RoleName:
        Fn::Sub: asf-${Env}-function-role
      AssumeRolePolicyDocument:
        Version: "2012-10-17"
        Statement:
          - Action: sts:AssumeRole
            Effect: Allow
            Principal:
              Service: lambda.amazonaws.com
      Policies:
        - PolicyName: DonGigasFunctionPolicy1
          PolicyDocument:
            Version: "2012-10-17"
            Statement:
              - Effect: Allow
                Action:
                  - sqs:SendMessage
                  - sqs:DeleteMessage
                  - sqs:ChangeMessageVisibility
                  - sqs:ReceiveMessage
                  - sqs:GetQueueAttributes
                  - sns:Publish
                  - logs:CreateLogGroup
                  - logs:CreateLogStream
                  - logs:PutLogEvents
                  - ec2:CreateNetworkInterface
                  - ec2:DescribeNetworkInterfaces
                  - ec2:DeleteNetworkInterface
                  - cloudwatch:PutMetricData
                Resource:
                  # FIXME: apply least priviledge
                  - "*"

  MainFunction:
    Type: AWS::Serverless::Function
    Properties:
      FunctionName:
        Fn::Sub: asf-${Env}-function
      Handler: build/handler.handler
      CodeUri: ../Lambdas/Main/build/
      Runtime: nodejs16.x
      Architectures:
        - arm64
      MemorySize: 128
      Timeout:
        Ref: FunctionTimeout
      Role:
        Fn::GetAtt: FunctionRole.Arn
      Description: A simple example includes a HTTP get method to get all items from a DynamoDB table.
      Environment:
        Variables:
          QUEUE_URL:
            Ref: MessageQueue
          ENV:
            Ref: Env

  MainFunctionLogGroup:
    Type: AWS::Logs::LogGroup
    Properties:
      LogGroupName:
        Fn::Sub: "/aws/lambda/DonGigasFunction"
      RetentionInDays: 7

  MessageQueue:
    Type: AWS::SQS::Queue
    Properties:
      QueueName: DonGigasMessageQueue
      VisibilityTimeout:
        Ref: QueueTimeout
      MessageRetentionPeriod: 3600
      RedrivePolicy:
        maxReceiveCount: 3
        deadLetterTargetArn:
          Fn::GetAtt: DLQueue.Arn

  DLQueue:
    Type: AWS::SQS::Queue
    Properties:
      QueueName: DonGigasDLQ
      MessageRetentionPeriod: 1209600 # 14J

Outputs:
  MainFunction:
    Description: "Function URL for MainFunction"
    Value:
      Fn::GetAtt: MainFunction.FunctionUrl
